(function ($) {
    'use strict';
    $(document).ready(function () {

        //we delay the init to avoid conflicts with plugin that hook on the select2 classes and create conflicts
        setTimeout(function () {
            $("#font").select2({allowClear: true});
        }, 500);

        load_select2();

        function load_select2(container)
        {
            if (typeof container == "undefined")
                container = "";
            $(container + " select.o-select2").each(function () {
//                console.log($(this));
                $(this).select2({allowClear: true});
            });
        }

        // Gérer l'affichage des opérateurs
        function hideoption(group, rule, valeur) {
            var h = 0;
            $.each(operators, function () {
                var op = $('#cld-pricing-group_' + group + '_rule_' + rule + '_' + h).val();
                var pricing_rules = $('select#cld-pricing-group_' + group + '_rule_' + rule + '_scope').val();
                
               
                if (valeur === 'if_selected_font') {
                    if (op !== "==" && op !== "!=") {
                        $('option#cld-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'none');
                    }
                } else {
                    $('option#cld-pricing-group_' + group + '_rule_' + rule + '_' + h).css('display', 'block');
                }
                // $('select#cld-pricing-group_' + group + '_rule_' + rule + '_scope option[value="item"]').show();       
                // if (pricing_rules == "item"){
                //     $('select#cld-pricing-group_' + group + '_rule_' + rule + '_scope option[value="item"]').hide();
                // }
                h++;
            });
        }

        /**
         * Function to automatically update the operators field
         */

        function cld_update_rule_operator(table_length, group_index, new_rule_index) {
            if (typeof (group_index) !== 'undefined' && typeof (new_rule_index) !== 'undefined') {
                var valeur = $('#cld-group_' + group_index + '_rule_' + new_rule_index + '_param   option:selected').val();
                hideoption(group_index, new_rule_index, valeur);
                $('#cld-group_' + group_index + '_rule_' + new_rule_index + '_param').change(function () {
                    valeur = $(this).val();
                    hideoption(group_index, new_rule_index, valeur);
                    $('#cld-pricing-group_' + group_index + '_rule_' + new_rule_index + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                });
            } else {
                var i = 0;
                while (i < table_length) {
                    var body_length = $('table.cld-rules-table.widefat tbody')[i].getElementsByTagName("tr").length;
                    var j = 0;
                    while (j < body_length) {
                        var valeur = $('#cld-group_' + i + '_rule_' + j + '_param   option:selected').val();
                        hideoption(i, j, valeur);
                        $('#cld-group_' + i + '_rule_' + j + '_param').change(function () {
                            var param_id = $(this).attr('id');
                            var par_tab = param_id.split('_');
                            var group = par_tab[1];
                            var rule = par_tab[3];
                            valeur = $(this).val();
                            hideoption(group, rule, valeur);
                            $('#cld-pricing-group_' + group + '_rule_' + rule + '_operator option[style="display: block;"]').eq(0).prop("selected", true);
                        });
                        j++;
                    }
                    i++;
                }
            }
        }
        //on document ready update rule operators
        var table_length = $('table.cld-rules-table.widefat').length;
        cld_update_rule_operator(table_length);

        /*
         * 
         * auto load font data
         */
        $(document).on('change', '#font', function () {
            var name = $('#font  option:selected').text();
            var url = $('#font   option:selected').val();
            $('.font_auto_name').val(name);
            $('.font_auto_url').val(url);

        });
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * 
         * Newsletter
         */
        $(document).on("click", "#cld-dismiss", function () {
            $.post(
                    cld_ajax_url,
                    {
                        action: "cld_hide_notice",
                    },
                    function (data) {
                        if (data === "ok") {
                            $('#cld-subscription-notice').hide();
                        }
                    })
                    .fail(function (xhr, status, error) {
                        alert(error);
                    });

        });

        $(document).on("click", "#cld-subscribe", function () {
            $("#cld-subscribe-loader").show();
            $("#cld-subscribe").attr("disabled", true);
            $("#cld-subscribe").addClass('disabled');
            if (!$('#o_user_email').val()) {
                alert('No email found. Please add an email address to subscribe.');
                $("#cld-subscribe-loader").hide();
                $("#cld-subscribe").attr("disabled", false);
                $("#cld-subscribe").removeClass('disabled');
            } else {
                var email = $('#o_user_email').val();
                var cld_subscription_nonce = $('#cld_subscription_nonce').val();
                $.post(
                        cld_ajax_object.cld_ajax_url,
                        {
                            action: "cld_subscribe",
                            email: email,
                            cld_subscription_nonce: cld_subscription_nonce
                        },
                        function (data) {
                            if (data === "true") {
                                $("#cld-subscribe-loader").hide();
                                $('#cld-subscription-notice').hide();
                                $('#cld-subscription-success-notice').show();
                            } else {
                                $("#cld-subscribe-loader").hide();
                                $("#cld-subscribe").attr("disabled", false);
                                $("#cld-subscribe").removeClass('disabled');
                                alert(data);
                            }
                        })
                        .fail(function (xhr, status, error) {
                            $("#cld-subscribe-loader").hide();
                            $("#cld-subscribe").attr("disabled", false);
                            $("#cld-subscribe").removeClass('disabled');
                            alert(error);
                        });
            }

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * add font file
         */

        $(document).on("click", ".o-add-font-file", function (e) {
            e.preventDefault();
            var uploader = wp.media({
                title: 'Please set the font',
                button: {
                    text: "Select font(s)"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var new_rule_index = $(".font_style_table tbody tr").length;
                                    var font_tpl = $("#cld-font-tpl").val();
                                    var tpl = font_tpl.replace(/{index}/g, new_rule_index);
                                    $('.font_style_table tbody').prepend(tpl);
                                    $('#file_data_' + new_rule_index).find("input[type=hidden]").val(attachment.id);
                                    $('#file_data_' + new_rule_index).parent().find(".media-name").html(attachment.filename);
                                }
                        );
                    })
                    .open();
        });
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * Remove font
         */
        $(document).on("click", ".o-remove-font-file", function (e) {
            e.preventDefault();
            $(this).parent().find("input[type=hidden]").val("");
            $(this).parent().parent().find(".media-name").html("");
            $(this).parent().parent().remove();
        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * canvas background color
         */
        $(document).on("change", ".cld-bg-type", function (e)
        {
            get_bg_fields_based_on_type();

        });

        if ($('.cld-bg-type').length > 0) {
            setTimeout(
                    function () {
                        get_bg_fields_based_on_type();
                    }, 1000);
        }

        function get_bg_fields_based_on_type()
        {
            $("[class*='show-if-canvas-']").hide();
            var selected_value = $('.cld-bg-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-canvas-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-canvas-colorpicker').show();
            } else {
                $('.show-if-canvas-colors').hide();
                $('.show-if-canvas-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text shadow color
         */
        $(document).on("change", ".cld-shadow-type", function (e)
        {
            get_shadow_fields_based_on_type();

        });

        if ($('.cld-shadow-type').length > 0) {
            setTimeout(
                    function () {
                        get_shadow_fields_based_on_type();
                    }, 1000);
        }

        function get_shadow_fields_based_on_type()
        {
            $("[class*='show-if-shadow-']").hide();
            var selected_value = $('.cld-shadow-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-shadow-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-shadow-colorpicker').show();
            } else {
                $('.show-if-shadow-colors').hide();
                $('.show-if-shadow-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide shadow fields
         */
        $(document).on("change", ".cld-enable-shadow", function (e)
        {
            get_shadow_fields_based_on_selection();

        });

        if ($('.cld-enable-shadow').length > 0) {
            setTimeout(
                    function () {
                        get_shadow_fields_based_on_selection();
                    }, 1000);
        }

        function get_shadow_fields_based_on_selection()
        {
            $('.cld-shadow-field').hide();
            var selected_value = $('.cld-enable-shadow input:checked').val();
            if (selected_value === "yes")
            {
                $('.cld-shadow-field').show();
                get_shadow_fields_based_on_type();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text outline color
         */
        $(document).on("change", ".cld-outline-type", function (e)
        {
            get_outline_fields_based_on_type();

        });

        if ($('.cld-outline-type').length > 0) {
            setTimeout(
                    function () {
                        get_outline_fields_based_on_type();
                    }, 1000);
        }

        function get_outline_fields_based_on_type()
        {
            $("[class*='show-if-outline-']").hide();
            var selected_value = $('.cld-outline-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-outline-colors').show();
            } else if (selected_value === "colorpicker")
            {
                $('.show-if-outline-colorpicker').show();
            } else {
                $('.show-if-outline-colors').hide();
                $('.show-if-outline-colorpicker').hide();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide outline fields
         */
        $(document).on("change", ".cld-enable-outline", function (e)
        {
            get_outline_fields_based_on_selection();

        });

        if ($('.cld-enable-outline').length > 0) {
            setTimeout(
                    function () {
                        get_outline_fields_based_on_selection();
                    }, 1000);
        }

        function get_outline_fields_based_on_selection()
        {
            $('.cld-outline-field').hide();
            var selected_value = $('.cld-enable-outline input:checked').val();
            if (selected_value === "yes")
            {
                $('.cld-outline-field').show();
                get_outline_fields_based_on_type();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * show / hide radius fields
         */
        $(document).on("change", ".cld-enable-radius", function (e)
        {
            get_radius_fields_based_on_selection();

        });

        if ($('.cld-enable-radius').length > 0) {
            setTimeout(
                    function () {
                        get_radius_fields_based_on_selection();
                    }, 1000);
        }

        function get_radius_fields_based_on_selection()
        {
            $('.cld-radius-field').hide();
            var selected_value = $('.cld-enable-radius input:checked').val();
            if (selected_value === "yes")
            {
                $('.cld-radius-field').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * show / hide spacing fields
         */
        $(document).on("change", ".cld-enable-spacing", function (e)
        {
            get_spacing_fields_based_on_selection();

        });

        if ($('.cld-enable-spacing').length > 0) {
            setTimeout(
                    function () {
                        get_spacing_fields_based_on_selection();
                    }, 1000);
        }

        function get_spacing_fields_based_on_selection()
        {
            $('.cld-spacing-field').hide();
            var selected_value = $('.cld-enable-spacing input:checked').val();
            if (selected_value === "yes")
            {
                $('.cld-spacing-field').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * text color type
         */
        $(document).on("change", ".cld-text-color-type", function (e)
        {
            get_text_colors_fields_based_on_type();

        });

        if ($('.cld-text-color-type').length > 0) {
            setTimeout(
                    function () {
                        get_text_colors_fields_based_on_type();
                    }, 1000);
        }

        function get_text_colors_fields_based_on_type()
        {
            $("[class*='show-if-text-']").hide();
            var selected_value = $('.cld-text-color-type input:checked').val();
            if (selected_value === "colors")
            {
                $('.show-if-text-colors').show();
            } else {
                $('.show-if-text-colorpicker').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /*
         * dimensions type
         */
        $(document).on("change", ".cld-dimensions-type", function (e)
        {
            get_dimensions_fields_based_on_type();

        });

        if ($('.cld-dimensions-type').length > 0) {
            setTimeout(
                    function () {
                        get_dimensions_fields_based_on_type();
                    }, 1000);
        }

        function get_dimensions_fields_based_on_type()
        {
            $("[class*='show-if-dimensions-']").hide();
            var selected_value = $('.cld-dimensions-type input:checked').val();
            if (selected_value === "font-size")
            {
                $('.show-if-dimensions-font').show();
            } else {
                $('.show-if-dimensions-canvas').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * Rules
         */
        $(document).on("click", ".cld-add-rule", function (e)
        {
            var new_rule_index = $(".cld-rules-table tr").length;
            var group_index = $(this).data("group");
            var raw_tpl = $("#cld-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            $(this).parents(".cld-rules-table").find("tbody").append(tpl2);
            $(this).parents(".cld-rules-table").find(".a_price").attr("rowspan", new_rule_index + 1);
            //update rule operators
            var table_length = $('table.cld-rules-table.widefat').length;
            cld_update_rule_operator('', group_index, new_rule_index);
        });

        $(document).on("click", ".cld-add-group", function (e)
        {
            var new_rule_index = 0;
            var group_index = $(".cld-rules-table").length;
            var raw_tpl = $("#cld-first-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            var html = '<table class="cld-rules-table widefat"><tbody>' + tpl2 + '</tbody></table>';
            $(".cld-rules-table-container").append(html);
            //update rule operators
            var table_length = $('table.cld-rules-table.widefat').length;
            cld_update_rule_operator('', group_index, new_rule_index);
        });

        $(document).on("click", ".cld-remove-rule", function (e)
        {
            var nb_rules = $(".cld-rules-table tr").length;
            $(this).parents(".cld-rules-table").find(".a_price").attr("rowspan", nb_rules - 1);
            $(this).parents("tr").remove();

        });
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * output format ------------------------------------------------------------------------
         */
        function get_output_fields_based_on_format()
        {
            $("[class*='show-if-']").hide();
            var selected_value = $('.config-output-format input:checked').val();
//            console.log(selected_value);
            if (selected_value.indexOf("pdf") >= 0)
            {
                $('.show-if-pdf').show();
                $('.hide-if-pdf').hide();
            } else
            {
                $('.show-if-pdf').hide();
                $('.hide-if-pdf').show();
            }

            if (selected_value.indexOf("jpg") >= 0)
                $('.show-if-jpg').show();
            else
                $('.show-if-jpg').hide();

            //Zip output
            $(".show-if-zip").hide();
            var zip = $('.zip-output input:checked').val();
            if (zip == 'yes')
                $('.show-if-zip').show();
            else
                $('.show-if-zip').hide();
        }


        $(document).on("change", ".config-output-format input, .zip-output input", function (e)
        {
            get_output_fields_based_on_format();

        });

        if ($('.config-output-format').length) {
            get_output_fields_based_on_format();
        }
        /*
         * end ------------------------------------------------------------------------
         */



        /*
         * font type
         */
        $('#cld_fonts_selector').select2({
            tags: true,
            width: 500
          });
        
        $("ul.select2-selection__rendered").sortable({
            containment: 'parent'
        });
        
        $('#cld_fonts_selector').on('select2:select', function(e) {
            console.log('change');
            var element = $(this).find('[value="' + e.params.data.id + '"]');
            $(this).append(element);
            $(this).trigger('change');
          });

        $(document).on("change", ".cld-fonts-type", function (e)
        {
            get_fonts_field_based_on_type();

        });

        if ($('.cld-fonts-type').length) {
            get_fonts_field_based_on_type();
        }

        function get_fonts_field_based_on_type()
        {
            $("[class*='show-if-fonts-global-']").hide();
            var selected_value = $('.cld-fonts-type input:checked').val();

            if (selected_value.indexOf("no") >= 0)
            {
                $('.show-if-fonts-global-no').show();
            }
        }
        /*
         * end ------------------------------------------------------------------------
         */


        /*
         * load colorpicker ------------------------------------------------------------------------
         */
        $(document).on("click", ".o-color-btn", function () {
            console.log("clicked");
            load_color_picker();
        });

        function load_color_picker() {
            $('.o-color').each(function (index, element)
            {
                var e = $(this);
                var initial_color = e.val();
                e.css("border-left", "35px solid " + initial_color);
                $(this).parent().find('.o-color-btn').ColorPicker({
                    color: initial_color,
                    onShow: function (colpkr) {
                        $(colpkr).fadeIn(500);
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        e.css("border-left", "35px solid #" + hex);
                        e.val("#" + hex);
                        e.trigger("input");
                    }
                });
            });
        }
        /*
         * end ------------------------------------------------------------------------
         */

        /**
         * Redirection on the new ticket page once the user clicks on Request a feature on the menu
         */
        $(document).on("click", function (event) {
            var text = $(event.target).text();
            if ("Request a feature" === text) {
                event.preventDefault();
                window.open('https://orionorigin.freshdesk.com/support/tickets/new');
            }

        });

        /**
         * Show the modal box once the user clicks on the view design button
         */


        $(".cld-view-design").click(function (e) {
            var modal_id = $(this).attr('data-target');
            $(modal_id + '.cld-modal').omodal("show");
        });


        //Activate license.
        $("#cld-activate").on("click", function () {
            var code = 0;
            request_registration(code);
        });

        function request_registration(code) {
            $("#cld-spinner").css('display', 'inline-block');
            $.post(
                    cld_ajax_object.cld_ajax_url,
                    {
                        action: "cld_activate_license",
                        code: code
                    },
                    function (data) {
                        $("#cld-spinner").css('display', 'none');
                        switch (data) {
                            case "license_key_used_on_different_site":
                                if (confirm("This license key has been used for another website. Do you want to use it anyway? (this will deactivate the previous website activated)")) {
                                    var code = 1;
                                    request_registration(code);
                                } else {
                                    $('#cld-license-message').html("<p>Operation cancelled.</p>");
                                }
                                break;
                            case "200":
                                alert("Activation succeded! Your product is now activated");
                                document.location.reload(true);
                                break;
                            default:
                                alert(data);
                                $('#cld-license-message').html("<p>" + data + "</p>");
                                break;
                        }
                    })
                    .fail(function (xhr, status, error) {
                        $("#cld-spinner").css({display: "none"});
                        $('#cld-license-message').html("<p>Activation failed due to a network error. Please, retry later. </p>");
                        alert("Activation failed due to a network error. Please, retry later.");
                    });
        }


    });

})(jQuery);
