<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-cld-editor
 *
 * @author HL
 */
class Cld_Editor {

    public $item_id;
    public $root_item_id;
    public $cld_product;

    public function __construct($item_id) {
        if ($item_id) {
            $this->item_id = $item_id;
            $this->cld_product = new Cld_Product($item_id);
            $this->root_item_id = $this->cld_product->root_product_id;
        }
    }

    public function get_editor() {
        global $cld_settings;

        ob_start();
        $product = wc_get_product($this->item_id);
        if (!$product) {
            esc_attr_e('Error: Invalid product: ', 'cld');
            echo esc_attr($this->item_id);
            echo '<br>';
            esc_attr_e('1- Is your customization page defined as homepage?', 'cld');
            echo '<br>';
            esc_attr_e('2- Is your customization page defined as one of woocommerce pages?', 'cld');
            echo '<br>';
            esc_attr_e('3- Does the product you are trying to customize exists and is published in your shop?', 'cld');
            echo '<br>';
            esc_attr_e('4- Are you accessing this page from one of the product designer buttons?', 'cld') . '<br>';
            return;
        }

        if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1' && $_SERVER['REMOTE_ADDR'] != '::1') {
            if (!get_option('cld-license-key')) {
                echo '<br><h2>';
                esc_attr_e('You have not activated your license yet. Please, activate it in order to use this plugin.', 'cld');
                echo '</h2><br>';
                return;
            }
        }

        $cld_metas = $this->cld_product->settings;

        cld_init_canvas_vars($cld_metas, $product, $this);
        $skin = get_proper_value($cld_metas, 'skin', 'Cld_Default_Skin');
        $editor = new $skin($this, $cld_metas);

        $raw_output = $editor->cld_display();
        //Escaping output.
        $allowed_tags = cld_allowed_tags();
        wp_nonce_field('cld_generate_design', 'cld_generate_design_nonce');
        echo wp_kses($raw_output, $allowed_tags);
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
    }

}
