<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of class-cld-default-skin
 *
 */
class CLD_Default_Skin {

    public $editor;
    public $cld_metas;
    private $plugin_name ;
    private $version ;




    public function __construct($editor_obj, $cld_metas) {
        if ($editor_obj) {
            $this->editor = $editor_obj;
            $this->cld_metas = $cld_metas;
            $this->plugin_name = 'cld';
            if (defined('CLD_VERSION')) {
                $this->version = CLD_VERSION;
            } else {
                $this->version = '1.0.0';
            }
        }
    }

    /*
     * Header block
     */

    public function cld_get_editor_header() {
        ob_start();
        ?>
        <a href="#" data-slide-index="<?php echo esc_attr__('0', 'cld'); ?>" class="cld-tool-header" >
            <span class="ti-text cld-tool-icon "></span>
            <span class="cld-tool-title"><?php echo esc_html__('1. Enter your text', 'cld'); ?></span>
        </a>
        <a href="#" data-slide-index="<?php echo esc_attr__('1', 'cld'); ?>" class="cld-tool-header" >
            <span class="ti-palette cld-tool-icon"></span>
            <span class="cld-tool-title"><?php echo esc_html__('2. Style your text', 'cld'); ?></span>
        </a>
        <a href="#" data-slide-index="<?php echo esc_attr__('2', 'cld'); ?>" class="cld-tool-header" >
            <span class="ti-shopping-cart cld-tool-icon"></span>
            <span class="cld-tool-title"><?php echo esc_html__('3. Add to cart', 'cld'); ?></span>
        </a>
        <?php
        echo ob_get_clean();
    }

    /*
     * Text block
     */

    public function cld_get_text_block($hide_preview_btn="") {
        $config_metas = $this->cld_metas;
        $show_style = get_proper_value($config_metas, 'enable-style', 'yes');
        $enable_spacing = get_proper_value($config_metas, 'enable-spacing', 'yes');
        $spacing_max = get_proper_value($config_metas, 'spacing-max', 30);
        $enable_alignment = get_proper_value($config_metas, 'enable-alignment', 'yes');
        $enable_reverse = get_proper_value($config_metas, 'enable-reverse', 'yes');
        ?>
        <div class="cld-row">
            <input type="text" class="cld-textarea" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false" value="<?php echo esc_html__('Your text', 'cld'); ?>" >


        </div>
        <?php if ($enable_alignment === 'yes') { ?>
            <div class="cld-row">
                <div class="cld-col left-col">
                    <span><?php echo esc_html__('Text alignment', 'cld'); ?><span>
                            </div>
                            <div class="cld-col right-col">
                                <input type="hidden" data-alignment="left" id="cld-text-alignment" readonly>
                                <span class="cld-alignments ti-align-left"></span>
                                <span class="cld-alignments ti-align-center"></span>
                                <span class="cld-alignments ti-align-right"></span>
                            </div>
                            </div>
                        <?php } ?>   

            <?php if ($show_style === 'yes') { ?>
            <div class="cld-row">
                <div class="cld-col left-col">
                    <span><?php echo esc_html__('Text style', 'cld'); ?><span>
                            </div>
                            <div class="cld-col right-col">
                                <input type="hidden" data-style="regular" id="cld-text-style" readonly>
                                <span class="cld-styles cld-regular ti-text"></span>
                                <span class="cld-styles cld-bold ti-text"></span>
                                <span class="cld-styles cld-italic ti-Italic"></span>
                            </div>
            </div>
    <?php } ?>

                        <div class="cld-row">
                            <?php if ($enable_spacing === 'yes') { ?>
                                <div class="cld-col left-col cld-hidden-tools">
                                    <span class="cld-dropdown"><?php echo esc_html__('Character spacing', 'cld'); ?></span>
                                    <div class="cld-tools-container">
                                        <div class="cld-range-slider-container">
                                            <div class="cld-range-slider">
                                                <span class="ti-minus cld-range-minus cld-char-minus"></span>
                                                <input class="cld-range-slider__range" id="cld-spacing-range" type="range" value="0" min="0" max="<?= $spacing_max ?>" step="1">
                                                <span class="cld-range-slider-value">1</span>
                                                <span class="ti-plus cld-range-plus cld-char-plus"></span>

                                            </div>
                                        </div>
                                    </div>
                                </div>
                            <?php }  ?>
                        </div>

                        <?php
                    }

                    /*
                     * Style block
                     */

                    public function cld_get_editor_style_block($hide_preview_btn="") {
                        $config_metas = $this->cld_metas;
                        $use_global_fonts = get_proper_value($config_metas, 'global-fonts', 'yes');
                        $default_width = get_proper_value($config_metas, 'canvas-w', 144);
                        $default_height = get_proper_value($config_metas, 'canvas-h', 30);

                        $dimensions_type = get_proper_value($config_metas, 'dimensions-type', 'canvas-dimensions');
                        
                        $min_size = get_proper_value($config_metas, 'min-size', 12);
                        $max_size = get_proper_value($config_metas, 'max-size', 60);

                        $default_font_size = get_proper_value($config_metas, 'default-font-size');
                        $min_font_size = get_proper_value($config_metas, 'min-font-size');
                        $max_font_size = get_proper_value($config_metas, 'max-font-size');
                        
                        $font_size =  get_proper_value($config_metas, 'show-fontsize');

                     
                        $enable_shadow = get_proper_value($config_metas, 'enable-shadow', 'no');
                        $shadow_max = get_proper_value($config_metas, 'shadow-max', 10);

                        $enable_outline = get_proper_value($config_metas, 'enable-outline', 'no');
                        $outline_max = get_proper_value($config_metas, 'outline-max', 10);
                        $keep_ratio = get_proper_value($config_metas,'keep-ratio','yes');
                                                       

                        if ('canvas-dimensions' === $dimensions_type) {
                            $dimension_unit = get_proper_value($config_metas, 'canvas-dimensions-unit', 'mm');
                        } else {
                            $dimension_unit = get_proper_value($config_metas, 'font-dimensions-unit', 'mm');
                        }

                        if ('yes' === $use_global_fonts) {
                            $fonts = cld_add_ttfurl_to_font_array(get_option('cld-fonts'));
                           
                        } else {
                            $selected_fonts = get_proper_value($config_metas, 'selected-fonts', 'yes');
                            $fonts = cld_retrieve_fonts_data($selected_fonts);
                        }     
                        ?>
                        <input type="hidden" id="enable-ratio" data-enable-ratio ="<?php echo $keep_ratio; ?>">
                        <div class="cld-row cld-preview-font-wrap">
                            <div class="cld-col left-col cld-col-25">
                                <span><?php echo esc_html__('Font', 'cld'); ?></span>
                                <!--span id="cld-preview-block" class="cld-button ti-eye"></span-->
                            </div>
                            
                            <div class="cld-col right-col cld-col-75">
                                <div class="cld-font-picker">
                                    <div id="cld-font-input-cover"></div>
                                    <input type="text" name="font" value=""  data-fonturl="" data-boldfonturl="" data-bothfonturl="" data-italicfonturl="" class="cld-text-input" id="cld-font-input" readonly>
                                    <ul class="hidden"  style="overflow:scroll; height:200px;">
                                        <?php
                                       
                                       if(empty($fonts)){
                                            $fonts = cld_get_default_fonts();
                                        }
                                            foreach ($fonts as $font) {
                                                $ttf = '';
                                                if (isset($font['ttf'][0])) {
                                                    $ttf = $font['ttf'][0];
                                                }                            
                                                $bold = cld_get_font_styles($font[1], "bold");
                                                $italic = cld_get_font_styles($font[1], "italic");
                                               // $both = cld_get_font_styles($font[1], "bold-italic");
                                                echo "<li style='font-family:" . esc_attr($font[0]) . ";' data-fontname='" . esc_attr($font[0]) . "' data-ttf='" . esc_url($ttf) . "' data-fonturl='" . esc_attr($font[1]) . "' data-boldfonturl='" . esc_attr($bold) . "' data-italicfonturl='" . esc_attr($italic) . "'>" . esc_attr($font[0]) . '</li>';
                                            }
                                            
                                        ?>
                                    </ul>
                                </div>	

                                <style>
                                    span#cld-preview-block{
                                        display: none;
                                    }
                                </style>
                                <div id="cld-font-color-picker" class="cld-color-picker" data-tooltip-content=".cld-color-palette.font">
                                    <div class="cld-color" id="cld-text-color"></div>
                                    <input type="hidden" name="font-color" value="" data-color="" id="cld-font-color" data-price=""readonly>
                                    <div class="cld-color-palette-container">
                                        <div class="cld-color-palette font">
                                            <div class="cld-color-palette-content"></div>
                                        </div>
                                    </div>
                                </div>
                                <span id="cld-preview-block"><a class="cld-button" data-toggle="o-modal" data-target="#test"><?php echo __("Preview all fonts","cld");?></a></span>
                            </div>



                            <div class="omodal fade o-modal cld-modal cld_part" id="test" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
                                <div class="omodal-dialog">
                                    <div class="omodal-content">
                                        <div class="omodal-header">
                                            <button id="close" type="button" class="close" data-dismiss="omodal" aria-hidden="true">&times;</button>
                                            <h4 class="omodal-title"><?php echo __("List Preview","cld");?></h4>
                                        </div>
                                        <div class="omodal-body txt-center">
                                            <div id="cld-preview-block-content"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>							



                        <div id="cld-canvas-color-block" class="cld-row">
                            <div class="cld-col left-col">
                                <span><?php echo esc_html__('Background color', 'cld'); ?></span>
                            </div>
                            <div class="cld-col right-col">
                                <div id="cld-canvas-color-picker" class="cld-color-picker" data-tooltip-content=".cld-color-palette.canvas">
                                    <div class="cld-color" id="cld-canvas-bg"></div>
                                    <input type="hidden" name="canvas-color" value="" data-color="" id="cld-canvas-color" readonly>
                                    <div class="cld-color-palette-container">
                                        <div class="cld-color-palette canvas">
                                            <div class="cld-color-palette-content"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

        <?php if ($dimensions_type === "font-size") { ?>
                            <div class="cld-row">
                                <div class="cld-row">
                                    <div class="cld-col left-col">
                                        <span><?php echo esc_html__('Font size', 'cld'); ?></span>
                                        <span class="cld-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("Enter the desired font size.", "cld")?>" >?</span>
                                    </div>
                                    <div class="cld-col right-col">
                                        <input type="number" name="cld-font-size" id="cld-font-size" value="<?php echo esc_attr($min_size); ?>" min="<?php echo esc_attr($min_size); ?>" max="<?php echo esc_attr($max_size); ?>" class="cld-text-input size-input"  autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
            <?= $dimension_unit; ?>    
                                    </div>
                                    <input type="hidden" name="canvas-custom-width" id="canvas-custom-width" value="">
                                    <input type="hidden" name="canvas-custom-height" id="canvas-custom-height" value="">
                                </div>
                            </div>
        <?php } else { ?>
                            <div class="cld-row">
                                <div class="cld-row">
                                    <div class="cld-col left-col">
                                        <span><?php echo esc_html__('Canvas size', 'cld'); ?></span>
                                        <span class="cld-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("Enter requested height or width and press UPDATE SIZE button. The other dimension will be calculated proportionaly.", "cld") ?>">?</span>
                                    </div>
                                    <div class="cld-col right-col">
                                        <input type="text" name="canvas-custom-width" id="canvas-custom-width" value="<?php echo esc_attr($default_width); ?>" class="cld-text-input size-input"  autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                        <span>X</span>
                                        <input type="text" name="canvas-custom-height" id="canvas-custom-height" value="<?php echo esc_attr($default_height); ?>" class="cld-text-input size-input" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                    </div>
                                    <input type="hidden" name="cld-font-size" id="cld-font-size" value="">
                                </div>
                                <div class="cld-row">
                                    <div class="cld-col right-col w100">
                                        <span><?php echo esc_html__('(width x height) ', 'cld'); ?><?= $dimension_unit; ?>  </span>
                                    </div>
                                </div>
                            </div>
                        <?php }
                          if("front" == $keep_ratio){
                            ?>
                            <div class="cld-col left-col">
                               <span><?php _e('Enable ratio : '); ?></span>
                            </div>
                            <div class="cld-col right-col">
                              <input class="cld_check_ratio" type="checkbox">
                            </div>
                        <?php
                        }
                        if ($default_font_size){
                            ?>
                            <div class="cld-row">
                                <div class="cld-col right-col w100">
                                    <div class="cld-col left-col">
                                        <span><?php echo esc_html__('Font size : ', 'cld'); ?></span> 
                                    </div>
                                    <div class="cld-col right-col">
                                        <input type="text" name="canvas-font-size" id="canvas-font-size" min="<?php echo esc_attr($min_font_size); ?>"  max="<?php echo esc_attr($max_font_size); ?>"   value="<?php echo esc_attr($default_font_size); ?>" class="cld-text-input size-input"  autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                    </div>
                                </div>
                            </div>
                        <?php
                        
                        if ( $enable_outline === 'yes' || $hide_preview_btn !== 'yes') {
                            ?>
                            <div class="cld-row ">
                                <?php
                                    if( $enable_outline === 'yes'){
                                       ?>
                                         <div class="cld-col left-col cld-hidden-tools">
                                            <span class="cld-dropdown"><?php echo esc_html__('Text effects', 'cld'); ?></span>
                                            <div class="cld-tools-container cld-bottom">

                                                    <?php if ($enable_outline === "yes") { ?>
                                                    <div class="cld-row">
                                                        <div class="cld-col left-col">
                                                            <span><?php echo esc_html__('Outline', 'cld'); ?></span>
                                                            <span class="cld-what-is-this" data-placement="top" data-tooltip-title="<?php echo esc_html__("This functionnality let you add an outline to your text.", "cld") ?>" >?</span>
                                                        </div>
                                                    </div> 
                                                    <div class="cld-row">
                                                        <div class="cld-col left-col cld-col-75">
                                                            <div class="cld-range-slider-container">
                                                                <div class="cld-range-slider cld-outline-slider">
                                                                    <span class="ti-minus cld-range-minus cld-shadow-minus"></span>
                                                                    <input class="cld-range-slider__range cld-outline-slider__range" id="cld-outline-range" type="range" value="0" min="0" max="<?= $outline_max ?>" step="1">
                                                                    <span class="cld-range-slider-value">0</span>
                                                                    <span class="ti-plus cld-range-plus cld-outline-plus"></span>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="cld-col right-col cld-col-25">
                                                            <div id="cld-outline-color-picker" class="cld-color-picker" data-tooltip-content=".cld-color-palette.outline">
                                                                <div class="cld-color" id="cld-text-outline-color"></div>
                                                                <input type="hidden" name="outline-color" value="" data-color="" id="cld-outline-color" readonly>
                                                                <div class="cld-color-palette-container">
                                                                    <div class="cld-color-palette outline">
                                                                        <div class="cld-color-palette-content"></div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                    <?php } ?>

                                            </div>
                                        </div>   
                                       <?php
                                    }
                                    if($hide_preview_btn !== 'yes'){
                                        ?>
                                            <div class="cld-col right-col">
                                                <button id="update-canvas-size" class="cld-button"><?php // echo esc_html__('Update', 'cld'); ?></button>
                                            </div>
                                        <?php
                                    }  
                                    
                                  
                                ?>
                                
                            </div>
                            <?php
                        }
                      }   
                    }

                                    /*
                                     * Action block
                                     */

                                    public function cld_get_editor_action_block() {
                        ?>
                        <div class="cld-row">
                            <div class="cld-col left-col w40">
                                <span><?php echo esc_html__('Quantity', 'cld'); ?><span>
                                        </div>
                                        <div class="cld-col w60">
                                            <div class="cld-quantity-container">
                                                <span class="ti-minus cld-qty-minus"></span>
                                                <input class="cld-quantity-field" name="quantity" type="number" value="1" min="1" step="1" autocomplete="off"  autocorrect="off" autocapitalize="off" spellcheck="false">
                                                <span class="ti-plus cld-qty-plus"></span>
                                            </div>
                                        </div>
                                        </div>
                                        <div class="cld-row">
                                            <div class="cld-price-title"><?php echo esc_html__('Price', 'cld'); ?></div>
                                            <div class="cld-price-container" id="cld-price">
                                            </div>
                                        </div>
                                        <div class="cld-row cld-last-row">
                                            <button id="cld-add-to-cart" data-id="<?php echo esc_attr($this->editor->item_id); ?>" class="cld-button"><?php echo esc_html__('Add to cart', 'cld') ?></button>
                                        </div>
                                        <?php
                                    }

                                    /*
                                     * footer block
                                     */

                                    public function cld_get_editor_footer($editor_notice) {
                                        ?>
                                        <div class="cld-row">
                                            <div class="cld-col left-col w80">
                                                <span class="cld-footer-text">
                                                    <?php echo $editor_notice; ?>
                                                </span>
                                            </div>


                                        </div>
                                        <?php
                                    }

                                    /*
                                     * Main function that handles the full display
                                     */

                                    public function cld_display() {
                                        global $cld_settings;
                                        $cld_settings = apply_filters('cld_global_settings', $cld_settings);
                                        $general_options = $cld_settings['cld-general-options'];
                                        if (isset($general_options['cld-hide-preview-button']) && !empty($general_options['cld-hide-preview-button'])) {
                                            $hide_preview_btn = $general_options['cld-hide-preview-button'];
                                        } else {
                                            $hide_preview_btn = "yes";
                                        }
                                        
                                        $hide_editor_notice = get_proper_value($general_options, 'cld-hide-editor-notice' , 'no');
                                        
                                        if(isset($general_options['cld-editor-notice'])){
                                            $editor_notice = $general_options['cld-editor-notice'];
                                        }else{
                                           $editor_notice = esc_html__("Please note: The surface colour is for illustrative purposes only and won't be produced. Self-adhesive vinyl letters are individually cut and come pre-spaced with application tape applied.", 'cld'); 
                                        }     
                            
                                        ob_start();
                                        $this->register_styles();
                                        $this->register_scripts();
                                        ?>

                                                <div class='cld-container o-wrap '>
                                                    <!--editor header-->
                                                    <div id="cld-header">
                                                        <?php
                                                        $this->cld_get_editor_header();
                                                        ?>
                                                    </div>

                                                    <!--tool boxes-->
                                                    <div id="cld-tools-container">

                                                        <!--text block -->
                                                        <div class="cld-tool-block">
                                                            <?php  $this->cld_get_text_block($hide_preview_btn); ?>
                                                        </div>

                                                        <!--style block -->
                                                        <div class="cld-tool-block">
                                                            <?php  $this->cld_get_editor_style_block($hide_preview_btn)  ; ?>
                                                        </div>

                                                        <!--cart block -->
                                                        <div class="cld-tool-block">
                                                            <?php $this->cld_get_editor_action_block(); ?>
                                                        </div>

                                                    </div>
                                                    <!--debug area-->
                                                    <span id="cld-admin-debug"  style="display : none;"></span>
                                                    <span id="cld-debug" style="display : none;"></span>
                                                    <!--editing area-->
                                                    <div id="cld-editing-area">
                                                    <?php
                                                            $config_metas = $this->cld_metas;
                                                            $canvas_w = get_proper_value($config_metas, 'canvas-w');
                                                            $canvas_h = get_proper_value($config_metas, 'canvas-h');
                                                            $canvas_dimensions_unit = get_proper_value($config_metas, 'canvas-dimensions-unit', 'mm');
                                                            $dimensions_type = get_proper_value($config_metas, 'dimensions-type', 'canvas-dimensions');
                                                            $show_baseline = get_proper_value($config_metas, 'show-baseline', 'yes');
                                                            ?>
                                                            <div id="cld-canvas-width">
                                                                <span class="size-w"> <?php echo esc_attr($canvas_w . $canvas_dimensions_unit); ?> </span>
                                                            </div>
                    
                                                            <div id="cld-canvas-height">
                                                                <span class="size-h"><?php echo esc_attr($canvas_h . $canvas_dimensions_unit); ?></span>
                                                            </div>
                    
                                                            <?php if ('canvas-dimensions' !== $dimensions_type && 'yes' === $show_baseline) { ?>
                                                            <div id="cld-baseline-height">
                                                                <span class="baseline-h"></span>
                                                            </div> 
                                                            <?php } ?>
                                                       

                                                            <canvas id="cld-canvas-area"></canvas> 
                                                            
                                                            <div id="cld-generate-image" data-default-width="<?php echo $canvas_w;?>"  data-default-height="<?php echo $canvas_h;?>" style="display:none;"></div>
                                                    </div>                     
                                                </div>
                                              

                                                    <!--footer block -->
                                                    <?php if('no' === $hide_editor_notice){
                                                        ?>
                                                           <div id="cld-footer">
                                                                <?php $this->cld_get_editor_footer($editor_notice); ?>
                                                            </div> 
                                                        <?php
                                                    }?>
                                                    
                                                </div>
        <?php
        $output = ob_get_clean();
        return $output;
    }

    /*
     * Register scripts
     */

    private function register_scripts() {
        wp_enqueue_script('cld-editor-js', CLD_URL . 'public/js/editor.js', array('jquery'), CLD_VERSION, false);
        wp_enqueue_script('cldd-accounting-js', CLD_URL . 'public/js/accounting.min.js', array('jquery'), CLD_VERSION, false);
        wp_enqueue_script('cld-block-UI-js', CLD_URL . 'public/js/blockUI/jquery.blockUI.min.js', array('jquery'), CLD_VERSION, false);
        wp_enqueue_script('fabric-js', CLD_URL . 'public/js/fabric.js', array('jquery'), $this->version, false);
        wp_enqueue_script($this->plugin_name, CLD_URL . 'public/js/cld-public.js', array('jquery'), $this->version, false);
        wp_localize_script($this->plugin_name, 'cld_ajax_object', array('cld_ajax_url' => admin_url('admin-ajax.php')));

        cld_register_scripts();
    }

    /*
     * Register styles files
     */

    private function register_styles() {
        cld_register_fonts($this->cld_metas);
    }

}
