(function ($) {
    'use strict';
    $(document).ready(function () {
        if (!('ontouchstart' in window)) {
            $(".cld-what-is-this").tooltip({
                title: function () {
                    return $(this).attr('data-tooltip-title');
                }
            });
        }

        function cld_remove_mini_cart_view_design() {
            $('.woocommerce-mini-cart .cld-view-design,.woocommerce-mini-cart .cld-modal').remove();
        }
        cld_remove_mini_cart_view_design()
        $(document).on('click', '.cld-view-design', function (e) {
            cld_remove_mini_cart_view_design();
        });

        $(".single_variation_wrap").on("show_variation", function (event, variation) {
            // Fired when the user selects all the required dropdowns / attributes
            // and a final variation is selected / shown
            var variation_id = $("input[name='variation_id']").val();
            if (variation_id) {
                $(".cld-buttons-wrap-variation").hide();
                $(".cld-buttons-wrap-variation[data-id='" + variation_id + "']").show();
            }
        });


        //creation des variables contenant les anciennes et nouvelles dimensions.
        var canvas_width_size_output;
        var canvas_height_size_output;
        var canvas_font_size_real_output;
        var canvas_width_size;
        var canvas_height_size;
        var canvas_width_dimensions;
        var cld_canvas_width;
        var cld_canvas_height;
        var cld_canvas_font_size;
        var cld_editing_area = $('div#cld-editing-area');
        var canvas = new fabric.Canvas('cld-canvas-area');
        var cld_output_values;
        var canvas_data_image;
        var limit_size_reached; 
        var cld_ratio;
        var  cld_width_limit;
        var  cld_height_limit;

        function get_mobile_view() {
            var windowsize = $(window).width();

            if (windowsize < 780) {
                var sliders = $('#cld-tools-container').bxSlider({
                    pagerCustom: '#cld-header',
                    controls: false,
                    infiniteLoop: false,
                    touchEnabled: false

                });

            }


        }
        get_mobile_view();
        $(window).resize(function () {
            get_mobile_view();
        });
        //        if (window.matchMedia("(min-width: 320px) and (max-width: 780px)").matches) {
        //
        //            var slider = $('#cld-tools-container').bxSlider({
        //                pagerCustom: '#cld-header',
        //                controls: false,
        //                infiniteLoop: false,
        //                touchEnabled: false,
        //                onSliderLoad: function () {
        //                    // $(".VPC_ln_Skin .components-slider").css("visibility", "visible");
        //                }
        //            });
        //        }



        //function to retrieve all data from the designer
        function cld_retrieve_designer_data() {
            var data = {};
            //retrieve the text in the textarea
            var enteredText = $('.cld-textarea').val();
            var formattedText = enteredText.replace(/\n/g, '<br/>');
            data["text"] = formattedText;

            //retrieve the selected font
            var font = $('#cld-font-input').val();
            data["font"] = font;

            //retrieve the selected font url
            var fonturl = $('#cld-font-input').attr('data-fonturl');
            data["font-url"] = fonturl;

            //retrieve the selected font ttf
            data["font-ttf"] = $('#cld-font-input').attr('data-ttf');

            var canvas_w = $('#canvas-custom-width').val();
            var canvas_h = $('#canvas-custom-height').val();

            //data['width'] = $("#cld-editing-area").width();
            //data['height'] = Math.round((canvas_h * data['width']) / canvas_w);

            data['width'] = canvas_w;
            data['height'] = canvas_h;

            data['custom-width'] = canvas_w;
            data['custom-height'] = canvas_h;

            //retrieve text color
            var text_color = $('#cld-font-color').attr("data-color");
            if (text_color === "") {
                text_color = 'white';
            }
            data['text_color'] = text_color;

            if (cld.text_palette_tpl_pricing !== 'undefined' && cld.text_palette_tpl_pricing != " ") {
                $.each(cld.text_palette_tpl_pricing, function (key, value) {
                    if (data['text_color'] == value['hex']) {
                        data['text_color_name'] = value['name'];
                    }
                });
            }

            //retrieve canvas color
            var canvas_color = $('#cld-canvas-color').attr("data-color");
            if (canvas_color === "") {
                canvas_color = 'black';
            }
            data['canvas_color'] = canvas_color;

            if (cld.bg_palette_tpl_pricing !== 'undefined' && cld.bg_palette_tpl_pricing != " ") {
                $.each(cld.bg_palette_tpl_pricing, function (key, value) {
                    if (data['canvas_color'] == value['hex']) {
                        data['canvas_color_name'] = value['name'];
                    }
                });
            }
            //retrieve shadow color
            var shadow_color = $('#cld-shadow-color').attr("data-color");
            data['shadow_color'] = shadow_color;



            // if (cld.shadow_palette_tpl_pricing !== 'undefined' && cld.shadow_palette_tpl_pricing != " ") {
            //     $.each(cld.shadow_palette_tpl_pricing, function (key, value) {
            //         if (data['shadow_color'] == value['hex']) {
            //             data['shadow_color_name'] = value['name'];
            //         }
            //     });
            // }

            var enable_ratio = $('input#enable-ratio').data('enable-ratio');
            data['enable_ratio'] = enable_ratio;

            //retrieve outline color
            var outline_color = $('#cld-outline-color').data("color");
            data['outline_color'] = outline_color;

            if (cld.outline_palette_tpl_pricing !== 'undefined' || cld.outline_palette_tpl_pricing != " ") {
                $.each(cld.outline_palette_tpl_pricing, function (key, value) {
                    if (data['outline_color'] == value['hex']) {
                        data['outline_color_name'] = value['name'];
                    }
                });
            }

            data['unit'] = cld.canvas_dimensions_unit;

            // //verify if reverse is checked
            // if ($('#cld-reverse-cut').prop('checked')) {
            //     data['reverse'] = "true";
            // } else {
            //     data['reverse'] = "false";
            // }

            //data['ratio'] = cld.keep_ratio;

            //alignment
            data['alignment'] = $('#cld-text-alignment').attr("data-alignment");

            //style
            data['style'] = $('#cld-text-style').attr("data-style");

            //letter spacing
            data['spacing'] = $("#cld-spacing-range").val();

            //verify if curved is checked
            //            if ($('#cld-enable-curving').prop('checked')) {
            //                data['enable-curving'] = "true";
            //            } else {
            //                data['enable-curving'] = "false";
            //            }

            //text curving
            //data['curving'] = $("#cld-curving-range").val();

            //text shadow
            data['shadow'] = $("#cld-shadow-range").val();


            //text outline
            data['outline'] = $("#cld-outline-range").val();

            //chosen font size
            data['font-size'] = $("#canvas-font-size").val();

            data['dimensions-type'] = cld.dimensions_type;

            return data;
        }


        //add design to cart
        $("#cld-add-to-cart").on("click", function (e) {
            $.blockUI({
                message: cld.translated_strings.loading_msg
            });
            var quantity = $(".cld-quantity-field").val();
            var frm_data = cld_retrieve_designer_data();
            var product_id = $(this).attr("data-id");
            if (typeof tpl === 'undefined') {
                var tpl = "";
            }
            var text_position = "left";
            if (frm_data.alignment != undefined) {
                text_position = frm_data.alignment;
            }

            frm_data["product_id"] = product_id;
            frm_data["quantity"] = quantity;

            if (frm_data.canvas_color == null) {
                frm_data.canvas_color = "black";
            }

            if (frm_data.text_color == null) {
                frm_data.text_color = "white";
            }



            //encode to json fabric.js canvas
            var canvas_jsons = JSON.stringify(canvas.toJSON());
            //decode it in order to modify value directly before generation of image
            canvas.clear();    
            var json_return = JSON.parse(canvas_jsons);
            //set rect width to output values
            if (canvas_width_size_output >= 17000) {
                canvas_width_size_output = 17000;
            }
            // if (canvas_height_size_output >= 13000) {
            //     canvas_width_size_output = 13000;
            // }
            canvas.setWidth(canvas_width_size_output);
            canvas.setHeight(canvas_height_size_output);  
            json_return.objects[0].width = canvas_width_size_output;
            //set rect height to output values
            json_return.objects[0].height = canvas_height_size_output;
            //set font size for text
            json_return.objects[1].fontSize = canvas_font_size_real_output;
            //set text width
            json_return.objects[1].width = canvas_width_size_output;
            var json_encoded = JSON.stringify(json_return);
                canvas.loadFromJSON(json_encoded,function () {
                var obj2 = canvas.getObjects();
                obj2[1].center();
                canvas_data_image = canvas.toDataURL();
            });
            $("span#cld-debug").empty().hide();

            //$text_position
            var canva_output = {
                cld_original_data: frm_data,
                cld_data_image: canvas_data_image,
                cld_canvas_preview_json: canvas_jsons,
                cld_canvas_output_json: json_encoded,
                product_id: product_id
            };
            var cld_generate_design_nonce = $('#cld_generate_design_nonce').val();
            $.post(
                    cld_ajax_object.cld_ajax_url, {
                        action: "cld_add_custom_design_to_cart",
                        data: canva_output,
                        cld_generate_design_nonce: cld_generate_design_nonce,
                    },
                    function (answer) {
                        var response = JSON.parse(answer);
                        $("span#cld-debug").empty().show().append(response.message);
                        $.unblockUI();
                        if (cld.redirect_after === "1") {
                            window.location.href = response.url;
                        }
                    })
                .fail(function (response) {
                    $("span#cld-admin-debug").empty().append('the process has failed, please retry it.');
                });
        });

        //range slider value
        var rangeSlider = function () {
            var slider = $('.cld-range-slider-container'),
                range = $('.cld-range-slider__range'),
                value = $('.cld-range-slider-value');

            slider.each(function () {

                value.each(function () {
                    var value = $(this).prev().attr('value');
                    $(this).html(value);
                });

                range.on('input', function () {
                    $(this).next(value).html(this.value);
                });
            });
        };
        rangeSlider();

        $(document).on('touchstart click', '.cld-range-slider-container .cld-range-minus', function () {
            var recup_val = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").val();
            var recup_min = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").attr('min');
            var recup_step = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").attr('step');
            var new_val = parseInt(recup_val) - parseInt(recup_step);
            if (new_val >= recup_min) {

                $(this).parents(".cld-range-slider").find(".cld-range-slider__range").val(new_val);
                $(this).parents(".cld-range-slider").find(".cld-range-slider-value").html(new_val);
            }
            $(this).parent('.cld-range-slider').find('input.cld-range-slider__range').trigger('change');
        });

        $(document).on('touchstart click', '.cld-range-slider-container .cld-range-plus', function () {
            var recup_val = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").val();
            var recup_max = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").attr('max');
            var recup_step = $(this).parents(".cld-range-slider").find(".cld-range-slider__range").attr('step');
            var new_val = parseInt(recup_val) + parseInt(recup_step);
            if (new_val <= recup_max) {

                $(this).parents(".cld-range-slider").find(".cld-range-slider__range").val(new_val);
                $(this).parents(".cld-range-slider").find(".cld-range-slider-value").html(new_val);
            }
            $(this).parent('.cld-range-slider').find('input.cld-range-slider__range').trigger('change');
        });

        $(document).on('click touchstart', function () {
            $('.cld-tools-container').hide();
        });
        $(document).on('click', '.cld-dropdown', function () {
            $('.cld-tools-container').hide();
            $(this).parents('.cld-hidden-tools').find('.cld-tools-container').toggle();
            return false;
        });
        $(document).on("click touchstart", ".cld-tools-container", function (event) {
            event.stopPropagation();

        });

        /**
         * Integration Fabric JS : 23/05/19
         */
        var hidden_image = $('div#cld-generate-image');

        /*
         * function to update the price (input and span)
         */

        function cld_update_price() {
            var additionnal_rules = cld.pricing_rules;
            var basing_price = parseFloat(cld.product_price);
            var text_palette_tpl_price = cld.text_palette_tpl_pricing;
            var bg_palette_tpl_price = cld.bg_palette_tpl_pricing;
            var shadow_palette_tpl_price = cld.shadow_palette_tpl_pricing;
            var outline_palette_tpl_price = cld.outline_palette_tpl_pricing;
            var text_color_price = 0;
            var bg_color_price = 0;
            var shadow_color_price = 0;
            var outline_color_price = 0;
            var additionnal_price_per_item = 0;
            var additionnal_price_on_design = 0;

          
            //retrieve text color
            if ($('#cld-font-color').lenght) {
                var text_color = $('#cld-font-color').attr("data-color").toUpperCase();
                if (typeof text_palette_tpl_price !== 'undefined') {
                    $.each(text_palette_tpl_price, function (index, text) {
                        if (text.hex.toUpperCase() === text_color || text.name.toUpperCase() === text_color) {
                            if ($.isNumeric(parseFloat(text.price))) {
                                text_color_price = parseFloat(text.price);
                            }
                        }
                    });
                }
            }

            //retrieve canvas color
            if ($('#cld-canvas-color').lenght) {
                var canvas_color = $('#cld-canvas-color').attr("data-color").toUpperCase();
                if (typeof bg_palette_tpl_price !== 'undefined') {
                    $.each(bg_palette_tpl_price, function (index, bg) {
                        if (bg.hex.toUpperCase() === canvas_color || bg.name.toUpperCase() === canvas_color) {
                            if ($.isNumeric(parseFloat(bg.price))) {
                                bg_color_price = parseFloat(bg.price);
                            }
                        }
                    });
                }
            }

            //retrieve shadow color
            if ($('#cld-shadow-color').lenght) {
                var shadow_color = $('#cld-shadow-color').attr("data-color").toUpperCase();
                var shadow_val = $('#cld-shadow-range').val();
                if (typeof shadow_palette_tpl_price !== 'undefined') {
                    $.each(shadow_palette_tpl_price, function (index, shadow) {
                        if (shadow.hex.toUpperCase() === shadow_color || shadow.name.toUpperCase() === shadow_color && parseInt(shadow_val) > 0) {
                            if ($.isNumeric(parseFloat(shadow.price))) {
                                shadow_color_price = parseFloat(shadow.price);
                            }
                        }
                    });
                }
            }


            //retrieve outline color
            if ($('#cld-outline-color').lenght) {
                var outline_color = $('#cld-outline-color').attr("data-color").toUpperCase();
                var outline_val = $('#cld-outline-range').val();
                if (typeof outline_palette_tpl_price !== 'undefined') {
                    $.each(outline_palette_tpl_price, function (index, outline) {
                        if (outline.hex.toUpperCase() === outline_color || outline.name.toUpperCase() === outline_color && parseInt(outline_val) > 0) {
                            if ($.isNumeric(parseFloat(outline.price))) {
                                outline_color_price = parseFloat(outline.price);
                            }
                        }
                    });
                }
            }

            if (typeof additionnal_rules !== 'undefined') {
                $.each(additionnal_rules, function (key, rule) {
                    var verify_result = cld_verify_condition(rule);
                    if (verify_result) {
                        if (verify_result.verify) {
                            additionnal_price_per_item = additionnal_price_per_item + parseFloat(verify_result.additionnal_price);
                            if ($.isNumeric(parseFloat(rule.a_price))) {
                                if (rule.scope === 'design') {
                                    additionnal_price_on_design = additionnal_price_on_design + parseFloat(rule.a_price);
                                }
                            }
                        }
                    }
                });
            }
            var qty = parseInt($(".cld-quantity-field").val());
            var total = (parseFloat(basing_price) + parseFloat(text_color_price) + parseFloat(bg_color_price) + parseFloat(shadow_color_price) + parseFloat(outline_color_price) + parseFloat(additionnal_price_per_item) + parseFloat(additionnal_price_on_design)) * parseInt(qty);
            $("#cld-price").html(accounting.formatMoney(total));
        }


        function cld_verify_condition(rule) {
            if (typeof rule !== 'undefined') {
                var comparaison_result = [];
                $.each(rule.rules, function (index, this_rule) {
                    if (typeof this_rule !== 'undefined' && this_rule.param !== 'undefined') {
                        //retrieve the text in the textarea
                        var enteredText = $('.cld-textarea').val();
                        var formattedText = enteredText.replace(/\n/g, '<br/>');
                        switch (this_rule.param) {
                            case "txt_nb_chars":
                                if (typeof formattedText !== 'undefined') {
                                    var text_size = formattedText.length;
                                    comparaison_result.push(cld_operator(this_rule.operator, text_size, this_rule.value));
                                }
                                break;
                            // case "txt_nb_lines":
                            //     if (typeof formattedText !== 'undefined') {
                            //         var text_nb_line = formattedText.split("<br/>").length;
                            //         comparaison_result.push(cld_operator(this_rule.operator, text_nb_line, this_rule.value));
                            //     }
                            //     break;
                            case "if_canvas_square_unit":
                                var canvas_w = parseInt($('#canvas-custom-width').val());
                                var canvas_h = parseInt($('#canvas-custom-height').val());
                                if (typeof canvas_w !== 'undefined' && typeof canvas_h != 'undefined') {
                                    var canvas_square = canvas_h * canvas_w;
                                    comparaison_result.push(cld_operator(this_rule.operator, canvas_square, this_rule.value));
                                }
                                break;
                            case "if_selected_font":
                                //retrieve the selected font
                                rule.scope = 'design';
                                var font = $('#cld-font-input').val();
                                if (typeof font !== 'undefined') {
                                    comparaison_result.push(cld_operator(this_rule.operator, font, this_rule.value));
                                }
                                break;
                            case "if_char_spacing":
                                //letter spacing
                                var space = parseInt($("#cld-spacing-range").val());
                                if (typeof space !== 'undefined') {
                                    comparaison_result.push(cld_operator(this_rule.operator, space, this_rule.value));
                                }
                                break;
                            case "if_font_size":
                                //Font size.
                                var data = cld_retrieve_designer_data();
                                var font_size = data['font-size'];
                                if (typeof font_size !== 'undefined') {
                                    comparaison_result.push(cld_operator(this_rule.operator, font_size, this_rule.value));
                                }
                                break;
                            default:
                                comparaison_result = comparaison_result;
                                break;
                        }
                    }
                });
                var verify = 0;
                $.each(comparaison_result, function (key, value) {
                    if (value.result) {
                        verify++;
                    }
                });
                var additionnal_price_per_item = 0;
                var result = [];
                result['verify'] = false;

                if (verify === comparaison_result.length) {
                    result['verify'] = true;
                    $.each(comparaison_result, function (key, value) {
                        if (rule.scope === 'item' && typeof (value.remaining_number) != 'undefined') {
                            additionnal_price_per_item = additionnal_price_per_item + (value.remaining_number * rule.a_price);
                        } else if (rule.scope === 'caracter') {
                            var enteredText = $('.cld-textarea').val();
                            var formattedText = enteredText.replace(/\n/g, '<br/>');
                            var text_size = formattedText.length;
                            additionnal_price_per_item = additionnal_price_per_item + (text_size * rule.a_price);
                        } else {
                            additionnal_price_per_item = additionnal_price_per_item + 0;
                        }
                    });
                    result['additionnal_price'] = additionnal_price_per_item;
                }
                return result;
            }
        }

        $("input#canvas-font-size").on('keyup',function(){
             const cld_max = parseInt($(this).attr('max'));
             var cld_value = parseInt($(this).attr('value'));
            if (cld_value > cld_max){
                $(this).val(cld_max);
            }   
        });
        
        function cld_operator(operator, giving_value, rule_value) {
            var data = [];
            if (operator === ">") {
                data['result'] = giving_value > rule_value;
                if (giving_value > rule_value) {
                    data['remaining_number'] = giving_value - rule_value;
                }
                return data;
            } else if (operator === ">=") {
                data['result'] = giving_value >= rule_value;
                if (giving_value >= rule_value) {
                    data['remaining_number'] = (giving_value - rule_value) + 1;
                }
                return data;
            } else if (operator === "<") {
                data['result'] = giving_value < rule_value;
                if (giving_value < rule_value) {
                    data['remaining_number'] = rule_value - giving_value;
                }
                return data;
            } else if (operator === "<=") {
                data['result'] = giving_value <= rule_value;
                if (giving_value < rule_value) {
                    data['remaining_number'] = (rule_value - giving_value) + 1;
                }
                return data;
            } else if (operator === "==") {
                data['result'] = giving_value == rule_value;
                if ($.isNumeric(parseInt(giving_value)) && $.isNumeric(parseInt(rule_value)) && giving_value === rule_value) {
                    data['remaining_number'] = giving_value;
                }
                return data;
            } else {
                data['result'] = giving_value != rule_value;
                if ($.isNumeric(parseInt(giving_value)) && $.isNumeric(parseInt(rule_value)) && giving_value !== rule_value) {
                    data['remaining_number'] = giving_value;
                }
                return data;
            }
        }


        function cld_calculate_dimensions(value, unit) {
            //1in => 300px
            //1px => 1px
            //1points => 4.16px
            //1mm => 12px
            //1cm => 118.11023622 px
            var dimensions;
            if (unit == "in") {
                dimensions = value * 300;
            } else if (unit == "px") {
                dimensions = value * 1;
            } else if (unit == "pt") {
                dimensions = value * 4.16;
            } else if (unit == "cm") {
                dimensions = value * 118, 11;
            } else if (unit == "mm") {
                dimensions = value * 12;
            }
            return dimensions;
        }

        function cld_calculate_limit_dimensions(value, unit) {
            //1in => 300px
            //1px => 1px
            //1points => 4.16px
            //1mm => 12px
            //1cm => 118.11023622 px
            var dimensions;
            if (unit == "in") {
                dimensions = value / 300;
            } else if (unit == "px") {
                dimensions = value / 1;
            } else if (unit == "pt") {
                dimensions = value / 4.16;
            } else if (unit == "cm") {
                dimensions = value / 118, 11;
            } else if (unit == "mm") {
                dimensions = value / 12;
            }
            return dimensions;
        }


        function cld_calculate_preview_dimensions(outerDimensions, dimensions) {
            var output_dimensions;
            var multiplier = outerDimensions / dimensions;
            output_dimensions = dimensions * multiplier;
            return output_dimensions;
        }

  

        function cld_view_preview() {
            var cld_canvas_data = cld_retrieve_designer_data();
            canvas_width_size = cld_canvas_data.width;
            canvas_height_size = cld_canvas_data.height;
            var canvas_unit = cld_canvas_data.unit;
            cld_canvas_width = canvas_width_size;
            cld_canvas_height = canvas_height_size;
                
            var cld_editing_area = $('#cld-editing-area');
            var cld_editing_area_outer_width = cld_editing_area.width();

            canvas_width_size_output = cld_calculate_dimensions(canvas_width_size, canvas_unit);
            canvas_height_size_output = cld_calculate_dimensions(canvas_height_size, canvas_unit);
            canvas_font_size_real_output = cld_calculate_dimensions(cld_canvas_data['font-size'], canvas_unit);
            canvas_width_dimensions = cld_calculate_preview_dimensions(cld_editing_area_outer_width, canvas_width_size_output);

            if (canvas_width_size_output > canvas_width_dimensions) {
                cld_canvas_width = canvas_width_dimensions;
                cld_ratio = canvas_width_dimensions / canvas_width_size_output;
                cld_canvas_height = canvas_height_size_output * cld_ratio;
            }else{
                cld_canvas_width = canvas_width_size_output ;
                cld_canvas_height = canvas_height_size_output;
            }

            canvas.clear();
            canvas.setWidth(cld_canvas_width);
            canvas.setHeight(cld_canvas_height);

            var cld_font_style;
            var cld_outline;

            if (cld_canvas_data.text_color == undefined || cld_canvas_data.text_color == " " ||  cld_canvas_data.text_color == null ) {
                cld_canvas_data.text_color = "white";
            }

            if (cld_canvas_data.canvas_color == null || cld_canvas_data.canvas_color == undefined || cld_canvas_data.canvas_color == " "){
                cld_canvas_data.canvas_color = "black";
            }



            cld_outline = cld_calculate_dimensions(cld_canvas_data.outline, cld_canvas_data.unit);
           
            cld_width_limit = cld_calculate_limit_dimensions(17000,canvas_unit);
            // cld_height_limit = cld_calculate_limit_dimensions(13000,canvas_unit);
           
            if (canvas_width_size_output > 17000){
                $("span#cld-admin-debug").empty().show().append('The maximum lettering width allowed is : '+cld_width_limit+'.'+canvas_unit);
            }

            
           
            // if (canvas_height_size_output >= 13000){
            //     $("span#cld-admin-debug").empty().show().append('The maximum lettering height allowed is : '+cld_height_limit+'.'+canvas_unit);
            // }



            $('span.size-w').html("").append(canvas_width_size+canvas_unit);
            $('span.size-h').html("").append(canvas_height_size+canvas_unit);
            $('div#cld-canvas-width').css('width',cld_canvas_width);
            $('div#cld-canvas-height').css('height',cld_canvas_height);



            var rect = new fabric.Rect({
                fill: cld_canvas_data.canvas_color,
                width: cld_canvas_width,
                height: cld_canvas_height,
                'selectable': false
            });

            
            var text = new fabric.Textbox(cld_canvas_data.text, {
                width: cld_canvas_width,
                fill: cld_canvas_data.text_color,
                fontSize: cld_canvas_width / canvas_width_size_output * canvas_font_size_real_output,
                textAlign: 'left',
                charSpacing: cld_canvas_data.spacing,
                fontFamily: cld_canvas_data.font,  
                'editable' : false,
                'selectable' : false        
            });
            if (cld_canvas_data.alignment != undefined) {
                text.set('textAlign', cld_canvas_data.alignment);
            }


            canvas.add(rect, text);

            var text_obj = canvas.getObjects()[1];
            text_obj.center();
            if (cld_canvas_data.style == "regular") {
                cld_font_style = "normal";
                text_obj.set('fontWeight', cld_font_style);
            } else if (cld_canvas_data.style == "bold") {
                cld_font_style = "bold";
                text_obj.set('fontWeight', cld_font_style);
            } else if (cld_canvas_data.style == 'italic') {
                cld_font_style = "italic";
                text_obj.set('fontStyle', cld_font_style);
            } else if (cld_canvas_data == "both") {
                cld_font_style = "oblique";
                text_obj.set('fontStyle', cld_font_style);
            }

            if (cld_canvas_data.outline_color){
                text_obj.set('stroke',cld_canvas_data.outline_color);
                text_obj.set('strokeWidth',cld_canvas_width / canvas_width_size_output * cld_outline)
            }
            canvas.renderAll();

           

        }

        function cld_render_default_values(){
            var canvas_default_value = $('div#cld-generate-image');
            const canvas_default_width = parseFloat(canvas_default_value.data('default-width'));
            const canvas_default_height = parseFloat(canvas_default_value.data('default-height'));

            var canvas_real_width = $('input#canvas-custom-width');
            var canvas_real_height = $('input#canvas-custom-height');

            canvas_real_width.on('keyup keydown',function(){
                canvas_height_size = canvas_real_width.val() * canvas_default_height / canvas_default_width;
                $('input#canvas-custom-height').removeAttr('value').attr('value',canvas_height_size);
            });

            canvas_real_height.on('keyup keydown',function(){
                canvas_width_size = canvas_real_height.val() * canvas_default_width / canvas_default_height ;
                $('input#canvas-custom-width').removeAttr('value').attr('value',canvas_width_size);
            });
        }


        $(document).on('change click keyup keydown ready mouseenter mouseleave', function (){
            var cld_canvas_data = cld_retrieve_designer_data();
            if (cld_canvas_data.enable_ratio == "front"){
                $('input#enable-ratio').show();
                $("input.cld_check_ratio").change(function() {
                    if(this.checked) {
                        cld_render_default_values();
                    }
                });
            }else if(cld_canvas_data.enable_ratio == "yes"){
                $('input#enable-ratio').show();
                cld_render_default_values();
            }
           
            cld_view_preview();
            cld_update_price();
        });


        $('.cld-text-input .size-input').on('change click keyup keydown keyleft keyright', function (){
            cld_view_preview();
        });

    });
})(jQuery);